      subroutine  eigen_trd_local_2update0(
     &     uxx, ux, vx,
     &     m, i, u_n, v_n)
!$    use OMP_LIB
      use eigen_devel
      use eigen_libs
      implicit NONE
!
      real(8), intent(INOUT) ::  uxx(*)
      real(8), intent(IN)    ::  ux(*), vx(*)
      integer, intent(IN)    ::  m, i
      real(8), intent(IN)    ::  u_n, v_n
!
      external               ::  daxpy
!
      integer                ::  j, k, L
      integer                ::  j_1, j_2, j_3, j_4
!
      include 'CSTAB.h'


      if ( m < 1 ) return
     
      L = i - 1

      j_2 = eigen_loop_start(1, x_nnod,x_inod)
      j_3 = eigen_loop_end  (L, x_nnod,x_inod)

      if ( j_3 >= j_2 ) then
#if 0
      call daxpy( j_3-j_2+1, -v_n, ux(j_2), 1, uxx(j_2), 1 )
      call daxpy( j_3-j_2+1, -u_n, vx(j_2), 1, uxx(j_2), 1 )
#else
#if 1
      uxx(j_2:j_3) = uxx(j_2:j_3) - v_n*ux(j_2:j_3) - u_n*vx(j_2:j_3)
#else
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
!IBM* INDEPENDENT
!IBM* ASSERT(NODEPS)
      do j_1=j_2,j_3
         uxx(j_1) = uxx(j_1)
     &            - (ux(j_1)*v_n + vx(j_1)*u_n)
      end do                    ! j_1
#endif
#endif
      end if

      return
      end subroutine  eigen_trd_local_2update0

