#!/bin/sh 

awk '/^!\$ /{ gsub(/^!\$ /,"   "); $0=$0 "!&!$@"} \
	/^\*/{ gsub(/^\*/,"!")} \
	/^c/{ gsub(/^c/,"!")} \
	/^#/{ print; next } \
	/^!/{ print; next } \
	/^[ ]*module[ ]*/{ gsub(/^[ ]*module[ ]*/,""); \
		module_name=$0; \
		print "      subroutine "module_name"!&!$="; next }\
	/^[ ]*interface[ ]*/{ \
		print "      end subroutine "module_name"!&!$-"; next }\
	/implicit/{ \
		gsub(/implicit[ ]*[Nn][Oo][Nn][Ee]/,"implicit NONE"); } \
	/intent/{ \
		gsub(/intent[ ]*\([Ii][Nn]\)/,"intent(IN)"); \
		gsub(/intent[ ]*\([Oo][Uu][Tt]\)/,"intent(OUT)"); \
		gsub(/intent[ ]*\([Ii][Nn][Oo][Uu][Tt]\)/,"intent(INOUT)"); } \
	/^[ ]*end[ ]*interface/{ \
		print "!"$0"!&!$."; next } \
	/^[ ]*end[ ]*module/{ \
		print "!"$0"!&!$+"; next } \
	/^[ ]*contains[ ]*$/{ \
		print "!"$0"!&!$:"; next } \
	{ if ( length($0) < 6 ) { \
		print; \
	   } else { \
		c=substr($0,6,1); \
		if ( c!=" " ) { $0=substr($0,1,5) "&" substr($0,7) } \
		print \
	   } \
	}' $1 > $1.oo

emacs --batch $1.oo \
	-f fortran-mode \
	-f mark-whole-buffer \
	--eval '(indent-region (point-min) (point-max) nil) ' \
	-f save-buffer

cat $1.oo | \
awk '/^#if[ ]+/{ gsub(/^#if[ ]+/,"#if ")} \
	/^![ ]+-/{ gsub(/^![ ]+-/, "!-")} \
	/^![ ]+\$$/{ gsub(/^![ ]+\$$/, "!$")} \
	/^![ ]+OCL/{ gsub(/^![ ]+OCL/, "!OCL")} \
	/^![ ]+IBM\*/{ gsub(/^![ ]+IBM\*/, "!IBM*")} \
	/^![ ]+DIR\$/{ gsub(/^![ ]+DIR\$/, "!DIR$")} \
	/^![ ]+CDIR\$/{ gsub(/^![ ]+CDIR\$/, "!CDIR$")} \
	/^![ ]+\$OMP/{ gsub(/^![ ]+\$OMP/, "!$OMP")} \
	/[ ]*!&!\$@[ ]*$/{ gsub(/[ ]*!&!\$@[ ]*$/,""); gsub(/^  /,"!$")} \
	/[ ]*!&!\$=[ ]*$/{ \
		gsub(/!&!\$=/,""); \
		module_name = $2; \
		gsub(/subroutine /,"module  ") } \
	/[ ]*!&!\$\-[ ]*$/{ \
		$0="      interface" }\
	/[ ]*!&!\$:[ ]*$/{ \
		$0="      contains" }\
	/[ ]*!&!\$\+[ ]*$/{ \
		$0="      end module  "module_name } \
	/[ ]*!&!\$.[ ]*$/{ \
		$0="      end interface" } \
	/ subroutine [a-zA-Z]/{ gsub(/ subroutine /," subroutine  ")} \
	/ function [a-zA-Z]/{ gsub(/ function /," function  ")} \
	/ type [a-zA-Z]/{ gsub(/ type /," type  ")} \
	{print}' | \
awk '/^![^\$]/{ print; next } \
	/^      [ ]*end[ ]*type[ ]*[a-zA-Z0-9_]*$/{ indent = 0 } \
	{ if ( indent ) { \
		left=substr($0,1,6); right=substr($0,7); \
		$0=left"   "right; \
	  } \
	  if ( length($0) > 72 ) { \
		left=substr($0,1,72); right=substr($0,73); \
		if( $0 ~ /^!\$/ ) { \
			print left; \
			print "!$   &" right \
		} else if ( left ~/!/ ) { \
			print left; \
			l = index(left,"!"); \
			for(i=0;i<l-1;i++)printf(" "); \
			print "!" right \
		} else { \
			c=split($0,a,"\"")-1; \
			if ( c>0 ) { if ( c%2 ) { \
				c=substr(left,72); \
				left=substr(left,1,71)"\"&"; \
				right =" // \"" c right; \
			} } \
			print left; \
			print "     &"right \
		} \
	   } else { \
		print \
	   } } \
	/^      [ ]*type[ ]*[a-zA-Z0-9_]*$/{ indent = 1 } \
	' > $1.pp

if [ -f $1.pp ]; then
	if [ x`diff -q $1.pp $1` = x ]; then
		echo 'Not updated'
	else
		mv $1 $1~
		mv $1.pp $1
	fi
fi

for f in  $1.pp $1.oo $1.oo~ ; do
	if [ -e $f ]; then
		if [ -f $f ]; then
			\rm $f;
		fi
	fi
done

